'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports["default"] = ally;

var _react = require('react');

var _storeShape = require('../utils/storeShape');

var _storeShape2 = _interopRequireDefault(_storeShape);

var _fieldShape = require('../utils/fieldShape');

var _fieldShape2 = _interopRequireDefault(_fieldShape);

var _shallowEqual = require('../utils/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _wrapActionCreators = require('../utils/wrapActionCreators');

var _wrapActionCreators2 = _interopRequireDefault(_wrapActionCreators);

var _warning = require('../utils/warning');

var _warning2 = _interopRequireDefault(_warning);

var _combinePath = require('../utils/combinePath');

var _combinePath2 = _interopRequireDefault(_combinePath);

var _set = require('../actions/set');

var _set2 = _interopRequireDefault(_set);

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

var _merge = require('lodash/merge');

var _merge2 = _interopRequireDefault(_merge);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DefaultFieldType = 'instance';
var defaultMapStateToProps = function defaultMapStateToProps(state) {
  return {};
}; // eslint-disable-line no-unused-vars
var defaultMapDispatchToProps = function defaultMapDispatchToProps(dispatch) {
  return { dispatch: dispatch };
};
var defaultMergeProps = function defaultMergeProps(stateProps, dispatchProps, parentProps, allyProps) {
  return _extends({}, parentProps, stateProps, allyProps, dispatchProps);
};

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

function sanitizeFields(fields) {
  for (var _iterator = Object.keys(fields), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
    var _ref;

    if (_isArray) {
      if (_i >= _iterator.length) break;
      _ref = _iterator[_i++];
    } else {
      _i = _iterator.next();
      if (_i.done) break;
      _ref = _i.value;
    }

    var fieldName = _ref;

    var field = fields[fieldName];
    field.name = field.name || fieldName;
    field.path = field.path || fieldName;
    field.type = field.type || DefaultFieldType;
    field.readonly = !!field.readonly;
  }
}

var errorObject = { value: null };
function tryCatch(fn, ctx) {
  try {
    return fn.apply(ctx);
  } catch (e) {
    errorObject.value = e;
    return errorObject;
  }
}

// Helps track hot reloading.
var nextVersion = 0;

// export default function ally(mapStateToProps, mapDispatchToProps, mergeProps, options = {}) {
function ally() {
  var allyOptions = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var defaultAllyOptions = {
    fields: {},
    mapStateToProps: null,
    mapDispatchToProps: null,
    mergeProps: null,
    options: {}
  };
  allyOptions = Object.assign({}, defaultAllyOptions, allyOptions);
  var _allyOptions = allyOptions;
  var fields = _allyOptions.fields;
  var mapStateToProps = _allyOptions.mapStateToProps;
  var mapDispatchToProps = _allyOptions.mapDispatchToProps;
  var mergeProps = _allyOptions.mergeProps;
  var options = _allyOptions.options;


  var shouldSubscribe = Boolean(mapStateToProps || fields.length > 0);
  var mapState = mapStateToProps || defaultMapStateToProps;

  var mapDispatch = void 0;
  if (typeof mapDispatchToProps === 'function') {
    mapDispatch = mapDispatchToProps;
  } else if (!mapDispatchToProps) {
    mapDispatch = defaultMapDispatchToProps;
  } else {
    mapDispatch = (0, _wrapActionCreators2["default"])(mapDispatchToProps);
  }

  var finalMergeProps = mergeProps || defaultMergeProps;
  var _options$pure = options.pure;
  var pure = _options$pure === undefined ? true : _options$pure;
  var _options$withRef = options.withRef;
  var withRef = _options$withRef === undefined ? false : _options$withRef;

  var checkMergedEquals = pure && finalMergeProps !== defaultMergeProps;

  sanitizeFields(fields);

  // Helps track hot reloading.
  var version = nextVersion++;

  return function wrapWithAlly(WrappedComponent) {
    var allyDisplayName = 'Ally(' + getDisplayName(WrappedComponent) + ')';

    function checkStateShape(props, methodName) {
      if (!(0, _isPlainObject2["default"])(props)) {
        (0, _warning2["default"])(methodName + '() in ' + allyDisplayName + ' must return a plain object. ' + ('Instead received ' + props + '.'));
      }
    }

    function computeMergedProps(stateProps, dispatchProps, parentProps, allyProps) {
      var mergedProps = finalMergeProps(stateProps, dispatchProps, parentProps, allyProps);
      if (process.env.NODE_ENV !== 'production') {
        checkStateShape(mergedProps, 'mergeProps');
      }
      return mergedProps;
    }

    var instanceNumber = 1;

    var Ally = function (_Component) {
      _inherits(Ally, _Component);

      Ally.prototype.shouldComponentUpdate = function shouldComponentUpdate() {
        return !pure || this.haveOwnPropsChanged || this.hasStoreStateChanged;
      };

      function Ally(props, context) {
        _classCallCheck(this, Ally);

        var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

        _this.version = version;
        _this.store = props.store || context.store;

        (0, _invariant2["default"])(_this.store, 'Could not find "store" in either the context or ' + ('props of "' + allyDisplayName + '". ') + 'Either wrap the root component in a <Provider>, ' + ('or explicitly pass "store" as a prop to "' + allyDisplayName + '".'));

        var storeState = _this.store.getState();
        _this.state = { storeState: storeState };
        _this.clearCache();
        _this.initializeAllyPropsWithDefaults();
        _this.componentName = getDisplayName(WrappedComponent);
        _this.instanceNumber = instanceNumber++;
        return _this;
      }

      Ally.prototype.initializeAllyPropsWithDefaults = function initializeAllyPropsWithDefaults() {
        this.allyProps = {};
        for (var _iterator2 = Object.keys(fields), _isArray2 = Array.isArray(_iterator2), _i2 = 0, _iterator2 = _isArray2 ? _iterator2 : _iterator2[Symbol.iterator]();;) {
          var _ref2;

          if (_isArray2) {
            if (_i2 >= _iterator2.length) break;
            _ref2 = _iterator2[_i2++];
          } else {
            _i2 = _iterator2.next();
            if (_i2.done) break;
            _ref2 = _i2.value;
          }

          var fieldName = _ref2;

          var field = fields[fieldName];
          var defaultValue = field.defaultValue;
          var name = field.name;

          this.allyProps[name] = defaultValue;
        }
      };

      Ally.prototype.computeStateProps = function computeStateProps(store, props) {
        if (!this.finalMapStateToProps) {
          return this.configureFinalMapState(store, props);
        }

        var state = store.getState();
        var stateProps = this.doStatePropsDependOnOwnProps ? this.finalMapStateToProps(state, props) : this.finalMapStateToProps(state);

        if (process.env.NODE_ENV !== 'production') {
          checkStateShape(stateProps, 'mapStateToProps');
        }
        return stateProps;
      };

      Ally.prototype.configureFinalMapState = function configureFinalMapState(store, props) {
        var mappedState = mapState(store.getState(), props);
        var isFactory = typeof mappedState === 'function';

        this.finalMapStateToProps = isFactory ? mappedState : mapState;
        this.doStatePropsDependOnOwnProps = this.finalMapStateToProps.length !== 1;

        if (isFactory) {
          return this.computeStateProps(store, props);
        }

        if (process.env.NODE_ENV !== 'production') {
          checkStateShape(mappedState, 'mapStateToProps');
        }
        return mappedState;
      };

      Ally.prototype.computeDispatchProps = function computeDispatchProps(store, props) {
        if (!this.finalMapDispatchToProps) {
          return this.configureFinalMapDispatch(store, props);
        }

        var dispatch = store.dispatch;

        var dispatchProps = this.doDispatchPropsDependOnOwnProps ? this.finalMapDispatchToProps(dispatch, props) : this.finalMapDispatchToProps(dispatch);

        if (process.env.NODE_ENV !== 'production') {
          checkStateShape(dispatchProps, 'mapDispatchToProps');
        }
        return dispatchProps;
      };

      Ally.prototype.configureFinalMapDispatch = function configureFinalMapDispatch(store, props) {
        var mappedDispatch = mapDispatch(store.dispatch, props);
        var isFactory = typeof mappedDispatch === 'function';

        this.finalMapDispatchToProps = isFactory ? mappedDispatch : mapDispatch;
        this.doDispatchPropsDependOnOwnProps = this.finalMapDispatchToProps.length !== 1;

        if (isFactory) {
          return this.computeDispatchProps(store, props);
        }

        if (process.env.NODE_ENV !== 'production') {
          checkStateShape(mappedDispatch, 'mapDispatchToProps');
        }
        return mappedDispatch;
      };

      Ally.prototype.computeAllyProps = function computeAllyProps() {
        this.configureFieldsForAlly();
        var allyProps = {
          allyFields: this.fields,
          allyComponentName: this.componentName,
          allyInstanceNumber: this.instanceNumber
        };

        var precomputedMergedProps = computeMergedProps(this.stateProps, this.dispatchProps, this.props, this.allyProps);

        //  these properties are so that the most up to date information is used
        //  when computing properties
        for (var _iterator3 = Object.keys(this.fields), _isArray3 = Array.isArray(_iterator3), _i3 = 0, _iterator3 = _isArray3 ? _iterator3 : _iterator3[Symbol.iterator]();;) {
          var _ref3;

          if (_isArray3) {
            if (_i3 >= _iterator3.length) break;
            _ref3 = _iterator3[_i3++];
          } else {
            _i3 = _iterator3.next();
            if (_i3.done) break;
            _ref3 = _i3.value;
          }

          var fieldName = _ref3;

          var field = this.fields[fieldName];
          Object.defineProperty(precomputedMergedProps, field.name, {
            configurable: true,
            enumerable: true,
            get: field.finalGetter,
            set: _noop2["default"]
          });
        }

        this.allyInstanceData = {
          props: precomputedMergedProps,
          state: this.state.storeState,
          dispatch: this.store.dispatch
        };
        for (var _iterator4 = Object.keys(this.fields), _isArray4 = Array.isArray(_iterator4), _i4 = 0, _iterator4 = _isArray4 ? _iterator4 : _iterator4[Symbol.iterator]();;) {
          var _ref4;

          if (_isArray4) {
            if (_i4 >= _iterator4.length) break;
            _ref4 = _iterator4[_i4++];
          } else {
            _i4 = _iterator4.next();
            if (_i4.done) break;
            _ref4 = _i4.value;
          }

          var _fieldName = _ref4;

          var _field = this.fields[_fieldName];
          var name = _field.name;
          var setterName = _field.setterName;
          var finalSetter = _field.finalSetter;

          tryCatch(_field.updatePath, this.allyInstanceData);
          allyProps[name] = _field.finalGetter();
          if (!_field.readonly) {
            allyProps[setterName] = finalSetter;
          }
        }
        if (process.env.NODE_ENV !== 'production') {
          checkStateShape(allyProps, 'mapDispatchToProps');
        }
        return allyProps;
      };

      Ally.prototype.configureFieldsForAlly = function configureFieldsForAlly() {
        var _this2 = this;

        if (this.fields) {
          return this.fields;
        }
        var instanceFields = _extends({}, fields);

        var _loop = function _loop() {
          if (_isArray5) {
            if (_i5 >= _iterator5.length) return 'break';
            _ref5 = _iterator5[_i5++];
          } else {
            _i5 = _iterator5.next();
            if (_i5.done) return 'break';
            _ref5 = _i5.value;
          }

          var fieldName = _ref5;

          var field = instanceFields[fieldName];
          var name = field.name;
          var type = field.type;
          var defaultValue = field.defaultValue;
          var getter = field.getter;
          var setter = field.setter;
          var readonly = field.readonly;

          var path = field.path;
          var pathPrefix = [];
          switch (type) {
            case 'component':
              pathPrefix.push(_this2.componentName);
              break;
            case 'instance':
              pathPrefix.push(_this2.componentName, 'instances', _this2.instanceNumber);
              break;
          }

          var doesPathDependOnInstance = typeof path === 'function';
          var doesGetterDependOnInstance = typeof getter === 'function';
          var doesSetterDependOnInstance = typeof setter === 'function';

          if (!doesPathDependOnInstance) {
            computedPath = path;
          }
          var finalPath = (0, _combinePath2["default"])(pathPrefix, computedPath);

          var updatePath = function updatePath() {
            if (doesPathDependOnInstance) {
              field.computedPath = path.call(_this2.allyInstanceData);
              field.finalPath = (0, _combinePath2["default"])(field.pathPrefix, field.computedPath);
            }
          };

          field.pathPrefix = pathPrefix;
          field.computedPath = computedPath;
          field.finalPath = finalPath;
          field.doesPathDependOnInstance = doesPathDependOnInstance;
          field.doesGetterDependOnInstance = doesGetterDependOnInstance;
          field.doesSetterDependOnInstance = doesSetterDependOnInstance;
          field.updatePath = updatePath;
          field.defaultGetter = function () {
            return (0, _get2["default"])(_this2.state.storeState, field.finalPath, defaultValue);
          };
          field.finalGetter = doesGetterDependOnInstance && function () {
            return getter.call(_this2.allyInstanceData, field.defaultGetter);
          } || field.defaultGetter;
          if (!readonly) {
            field.defaultSetter = function (value) {
              return function (dispatch) {
                return dispatch((0, _set2["default"])(field.finalPath, value));
              };
            };
            field.finalSetter = doesSetterDependOnInstance && function (value) {
              return setter.call(_this2.allyInstanceData, value, field.defaultSetter);
            } || field.defaultGetter;
            field.setterName = 'set' + name[0].toUpperCase() + name.slice(1);
          }
        };

        for (var _iterator5 = Object.keys(instanceFields), _isArray5 = Array.isArray(_iterator5), _i5 = 0, _iterator5 = _isArray5 ? _iterator5 : _iterator5[Symbol.iterator]();;) {
          var _ref5;

          var computedPath;

          var _ret = _loop();

          if (_ret === 'break') break;
        }

        this.fields = instanceFields;
      };

      Ally.prototype.updateStatePropsIfNeeded = function updateStatePropsIfNeeded() {
        var nextStateProps = this.computeStateProps(this.store, this.props);
        if (this.stateProps && (0, _shallowEqual2["default"])(nextStateProps, this.stateProps)) {
          return false;
        }

        this.stateProps = nextStateProps;
        return true;
      };

      Ally.prototype.updateDispatchPropsIfNeeded = function updateDispatchPropsIfNeeded() {
        var nextDispatchProps = this.computeDispatchProps(this.store, this.props);
        if (this.dispatchProps && (0, _shallowEqual2["default"])(nextDispatchProps, this.dispatchProps)) {
          return false;
        }

        this.dispatchProps = nextDispatchProps;
        return true;
      };

      Ally.prototype.updateAllyPropsIfNeeded = function updateAllyPropsIfNeeded() {
        var nextAllyProps = this.computeAllyProps();
        if (this.allyProps && (0, _shallowEqual2["default"])(nextAllyProps, this.allyProps)) {
          return false;
        }

        this.allyProps = nextAllyProps;
        return true;
      };

      Ally.prototype.updateMergedPropsIfNeeded = function updateMergedPropsIfNeeded() {
        var nextMergedProps = computeMergedProps(this.stateProps, this.dispatchProps, this.props, this.allyProps);
        if (this.mergedProps && checkMergedEquals && (0, _shallowEqual2["default"])(nextMergedProps, this.mergedProps)) {
          return false;
        }

        this.mergedProps = nextMergedProps;
        return true;
      };

      Ally.prototype.isSubscribed = function isSubscribed() {
        return typeof this.unsubscribe === 'function';
      };

      Ally.prototype.trySubscribe = function trySubscribe() {
        if (shouldSubscribe && !this.unsubscribe) {
          this.unsubscribe = this.store.subscribe(this.handleChange.bind(this));
          this.handleChange();
        }
      };

      Ally.prototype.tryUnsubscribe = function tryUnsubscribe() {
        if (this.unsubscribe) {
          this.unsubscribe();
          this.unsubscribe = null;
        }
      };

      Ally.prototype.componentDidMount = function componentDidMount() {
        this.trySubscribe();
      };

      Ally.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        if (!pure || !(0, _shallowEqual2["default"])(nextProps, this.props)) {
          this.haveOwnPropsChanged = true;
        }
      };

      Ally.prototype.componentWillUnmount = function componentWillUnmount() {
        this.tryUnsubscribe();
        this.clearCache();
      };

      Ally.prototype.clearCache = function clearCache() {
        this.fields = null;
        this.allyProps = null;
        this.dispatchProps = null;
        this.stateProps = null;
        this.mergedProps = null;
        this.haveOwnPropsChanged = true;
        this.hasStoreStateChanged = true;
        this.haveStatePropsBeenPrecalculated = false;
        this.statePropsPrecalculationError = null;
        this.renderedElement = null;
        this.finalMapDispatchToProps = null;
        this.finalMapStateToProps = null;
      };

      Ally.prototype.handleChange = function handleChange() {
        if (!this.unsubscribe) {
          return;
        }

        var storeState = this.store.getState();
        var prevStoreState = this.state.storeState;
        if (pure && prevStoreState === storeState) {
          return;
        }

        if (pure && !this.doStatePropsDependOnOwnProps) {
          var haveStatePropsChanged = tryCatch(this.updateStatePropsIfNeeded, this);
          if (!haveStatePropsChanged) {
            return;
          }
          if (haveStatePropsChanged === errorObject) {
            this.statePropsPrecalculationError = errorObject.value;
          }
          this.haveStatePropsBeenPrecalculated = true;
        }

        this.hasStoreStateChanged = true;
        this.setState({ storeState: storeState });
      };

      Ally.prototype.getWrappedInstance = function getWrappedInstance() {
        (0, _invariant2["default"])(withRef, 'To access the wrapped instance, you need to specify ' + '{ withRef: true } as the fourth argument of the connect() call.');

        return this.refs.wrappedInstance;
      };

      Ally.prototype.render = function render() {
        var haveOwnPropsChanged = this.haveOwnPropsChanged;
        var hasStoreStateChanged = this.hasStoreStateChanged;
        var haveStatePropsBeenPrecalculated = this.haveStatePropsBeenPrecalculated;
        var statePropsPrecalculationError = this.statePropsPrecalculationError;
        var renderedElement = this.renderedElement;

        var fieldsNotYetDefined = !this.fields && withRef;

        this.haveOwnPropsChanged = false;
        this.hasStoreStateChanged = false;
        this.haveStatePropsBeenPrecalculated = false;
        this.statePropsPrecalculationError = null;

        if (statePropsPrecalculationError) {
          throw statePropsPrecalculationError;
        }

        var shouldUpdateStateProps = true;
        var shouldUpdateDispatchProps = true;
        if (pure && renderedElement) {
          shouldUpdateStateProps = hasStoreStateChanged || haveOwnPropsChanged && this.doStatePropsDependOnOwnProps;
          shouldUpdateDispatchProps = haveOwnPropsChanged && this.doDispatchPropsDependOnOwnProps;
        }

        var haveStatePropsChanged = false;
        var haveDispatchPropsChanged = false;
        if (haveStatePropsBeenPrecalculated) {
          haveStatePropsChanged = true;
        } else if (shouldUpdateStateProps) {
          haveStatePropsChanged = this.updateStatePropsIfNeeded();
        }
        if (shouldUpdateDispatchProps) {
          haveDispatchPropsChanged = this.updateDispatchPropsIfNeeded();
        }
        var haveAllyPropsChanged = this.updateAllyPropsIfNeeded();

        var haveMergedPropsChanged = true;
        if (haveStatePropsChanged || haveDispatchPropsChanged || haveOwnPropsChanged || haveAllyPropsChanged) {
          haveMergedPropsChanged = this.updateMergedPropsIfNeeded();
        } else {
          haveMergedPropsChanged = false;
        }

        if (!haveMergedPropsChanged && renderedElement) {
          return renderedElement;
        }

        if (withRef) {
          this.renderedElement = (0, _react.createElement)(WrappedComponent, _extends({}, this.mergedProps, {
            ref: 'wrappedInstance'
          }));
        } else {
          this.renderedElement = (0, _react.createElement)(WrappedComponent, this.mergedProps);
        }

        return this.renderedElement;
      };

      return Ally;
    }(_react.Component);

    Ally.displayName = allyDisplayName;
    Ally.WrappedComponent = WrappedComponent;
    Ally.contextTypes = {
      store: _storeShape2["default"]
    };
    Ally.propTypes = {
      store: _storeShape2["default"]
    };

    if (process.env.NODE_ENV !== 'production') {
      Ally.prototype.componentWillUpdate = function componentWillUpdate() {
        if (this.version === version) {
          return;
        }

        // We are hot reloading!
        this.version = version;
        this.trySubscribe();
        this.clearCache();
      };
    }

    return (0, _hoistNonReactStatics2["default"])(Ally, WrappedComponent);
  };
}