"use strict";

exports.__esModule = true;
exports["default"] = remove;

var _allyActionNames = require('../utils/allyActionNames');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

//import invariant from 'invariant'

function remove(state, action) {
    if (!action || action.type !== _allyActionNames.REMOVE) {
        return state;
    }
    //TODO: properly apply error handling for malformed actions
    //invariant(action.payload, 'payload missing from action');
    var path = action.payload.path;
    //invariant(path, 'path missing from payload');

    if (!_lodash2["default"].hasIn(state, path)) {
        return state;
    }
    /*
        An interesting caveat here is that unset can fail if the property being unset 
        is not configurable. However, after returning the clone, the property will 
        lose the property of not being configurable, so performing the action
        twice on the same object will cause the value to be deleted. We expect
        this to not be an issue in most cases, and do not intend to correct this 
        behavior.
     */
    if (_lodash2["default"].unset(state, path)) {
        return _lodash2["default"].clone(state);
    } else {
        return state;
    }
}

remove.type = _allyActionNames.REMOVE;