"use strict";

exports.__esModule = true;
exports["default"] = set;

var _allyActionNames = require('../utils/allyActionNames');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

//import invariant from 'invariant'

function set(state, action) {
    if (!action || action.type !== _allyActionNames.SET) {
        return state;
    }
    //TODO: properly apply error handling for malformed actions
    //invariant(action.payload, 'payload missing from action');
    var _action$payload = action.payload;
    var path = _action$payload.path;
    var value = _action$payload.value;
    //invariant(path, 'path missing from payload');
    //invariant(typeof value !== 'undefined', 'value missing from payload');

    var oldValue = _lodash2["default"].get(state, path);
    if (_lodash2["default"].eq(oldValue, value)) {
        return state;
    }
    var newState = _lodash2["default"].clone(state);
    return _lodash2["default"].set(newState, path, value);
}

set.type = _allyActionNames.SET;